#ifndef	_BIT_WSN_INCLUDED_
#define _BIT_WSN_INCLUDED_

/* 802.15.4	*/
#define WSNC_CSMA_CA_MAX_BACKOFF_EXP		 5
#define WSNC_TX_FAILURE			 	      	-10
#define WSNC_TX_SUCCESS				      	-11
#define WSNC_INVALID_BACKOFF            	-12
#define WSNC_CLUSTER_HEAD_LOST 			  	-30
#define WSNC_JOIN_NET_CODE				    -40
#define WSNC_JOIN_NET_COMPLETE_CODE		    -41
#define WSNC_JOIN_NET_COMPLETE_CONFIRM_CODE -42
#define WSNC_JOIN_NET_FAILED_CODE           -43
#define WSNC_CLUSTERING_COMPLETE_CODE       -50
#define WSNC_NET_LOST_CODE				    -60
#define WSNC_PK_TYPE_DATA					0
#define WSNC_PK_TYPE_RELAY					1
#define WSNC_PK_TYPE_ACK			  		2
#define WSNC_PK_TYPE_CTRL					3
#define WSNC_PK_CTRL_TYPE_BEACON_SINK		0
#define WSNC_PK_CTRL_TYPE_JOIN_REQ_CH		1
#define WSNC_PK_CTRL_TYPE_JOIN_ACK_SINK		2
#define WSNC_PK_CTRL_TYPE_ADV_CH			3
#define WSNC_PK_CTRL_TYPE_JOIN_REQ_NODE		4
#define WSNC_PK_CTRL_TYPE_JOIN_ACK_CH		5
#define WSNC_PK_CTRL_TYPE_COMM_BEACON_CH	6
#define WSNC_PK_CTRL_TYPE_SYN_REQ  	    	7
#define WSNC_PK_CTRL_TYPE_SYN_ACK  	    	8
#define WSNC_PK_CTRL_TYPE_NM_CH		    	14
#define WSNC_PK_CTRL_TYPE_NM_SINK	    	15
#define WSNC_CTRL_PK_SIZE                   144
#define WSNC_DATA_PK_SIZE                   136
#define WSNC_SENSOR_DATA_SIZE_2             2
#define WSNC_SENSOR_DATA_SIZE_3             3
#define WSNC_SENSOR_DATA_SIZE_4             4
#define WSNC_DATA_FRAME_MHR_MFR_6		    6
#define WSNC_DATA_FRAME_MHR_MFR_8		    8
#define WSNC_DATA_FRAME_MHR_MFR_20		    20
#define WSNC_DATA_ACK_FRAME_MHR_MFR_4		 4
#define WSNC_DATA_ACK_FRAME_MHR_MFR_6	     6
#define WSNC_DATA_ACK_FRAME_MHR_MFR_8		 8
#define WSNC_DATA_ACK_FRAME_MHR_MFR_20		 20
#define WSNC_CTRL_FRAME_MHR_MFR_6		    6
#define WSNC_CTRL_FRAME_MHR_MFR_7		    7
#define WSNC_CTRL_FRAME_MHR_MFR_9		    9
#define WSNC_CTRL_FRAME_MHR_MFR_13		    13
#define WSNC_CTRL_FRAME_MHR_MFR_21		    21
#define WSNC_MAC_FRAME_LENGTH				128
#define WSNC_CTRL_FRAME_PAYLOAD_BEACON_SINK	18




#define WSNC_NODE_ONE_HOP_DIST_MAX		    3000
#define	WSNC_PROP_VELOCITY					3.0E+08
#define WSNC_NODE_ONE_HOP_PROP_DELAY_MAX  	(WSNC_NODE_ONE_HOP_DIST_MAX/WSNC_PROP_VELOCITY)
#define WSNC_TX_PROTECTION                  0.001
#define WSNC_PROP_PROTECTION				0.001
#define WSNC_TSB_RRN_MAX                    9
#define WSNC_TSB_A_B_C_BULK                 512
#define WSNC_TSB_UNIT_SLOT					0.0078125
#define WSNC_SLOT_FRAME_TIME                (WSNC_TSB_A_B_C_BULK*3*WSNC_TSB_UNIT_SLOT)
#define WSNC_JITTER_TIME                    0.000001
#define WSNC_TICK_TIME                      0.0001
#define WSNC_GATEWAY_JOIN_NET_OVERTIME      1	
#define WSNC_NODE_JOIN_NET_OVERTIME         1.01
#define WSNC_NODE_JOIN_NET_WAIT_OVERTIME    (WSNC_GATEWAY_JOIN_NET_OVERTIME + WSNC_NODE_JOIN_NET_OVERTIME +1)
#define WSNC_E_nJ  					       0.000000001	
#define WSNC_E_pJ  					       0.000000000001	
#define WSNC_E_TX                          (50*WSNC_E_nJ)
#define WSNC_E_RX                          (50*WSNC_E_nJ)
#define WSNC_E_FS                          (10*WSNC_E_pJ)
#define WSNC_E_MP                          (0.0013*WSNC_E_pJ)
#define WSNC_E_DA                          (5*WSNC_E_nJ)
#define WSNC_D_REF	                       sqrt(WSNC_E_FS/WSNC_E_MP)


double net_residual_energy;
int net_tx_data_num;
int net_tx_general_data_num;
int net_tx_alarm_data_num;
int net_rx_data_num;
int gateway_rx_general_data;
int gateway_rx_alarm_data;
int gateway_rx_data;
int gateway_tx_general_data;
int gateway_tx_alarm_data;
int gateway_tx_data;

int node_sensor_general_data;
int node_sensor_alarm_data;

typedef struct {
	
	int		cluster_head_addr;
	
	double	initial_energy;   
	double	current_energy;	
	
	double	pos_x;            
	double	pos_y;
	
	Boolean joined_net;       	
	
	int		time_level;       	
	
	int     traffic_level;    
	
	
	int		task_level;        
	
	int     energy_level;      
	

}Node_state_info;

typedef struct {
	int     sink_id;           
	int		cluster_id;        
	double	pos_x;             
	double	pos_y;	
	Boolean joined_net;        
	int		time_level;        
	Boolean need_sychronization;

}Gateway_state_info;
typedef struct{
	
	int    gateway_id;
	int    cluster_id; 

}Gateway_info;


typedef struct {

	double 		symbol_rate;             
	double		rx_power_threshold;       
	int 		is_retransmission;         
	Packet* 	retry_csma_ca_trans_pkptr; 

}WSN_modmem_info;


typedef struct{

	int     traffic_level; 
	int		task_level;    
	 
	int     energy_level;  

}Ctrl_info_TSB_req_node;

typedef struct{

	int		cluster_id;
	
	int		set;    
	int		index;  
	int		RRN;    

}Ctrl_info_join_ack_CH;
typedef struct{

    int		  cluster_id;

}Ctrl_info_join_ack_sink;

typedef struct{

    double  beacon_time;      
	double  next_beacon_time;  
	int     usable_TSB_number;
	
	
}Ctrl_info_comm_beacon_CH;

typedef struct{

    double  beacon_time;       
	double	pos_x;            
	double	pos_y;	
	
}Ctrl_info_beacon_sink;

typedef struct{

    int   member_id;     
	
	int   traffic_level; 
	int	  task_level;   
	int   energy_level; 
	
	int	  set;          
	int	  index;        
	int	  RRN;        
	
	int   slot_status;  
	int   is_new;       

}Assigned_TSBs_info_CH;

typedef struct{

	List*  data_info_list_ptr;  

}Data_frame_payload;

typedef struct{

	Objid  		owner;         
	double 		creation_time; 
	double 		node_xmt_time; 
	double 		ch_rcv_time;   
	double 		ch_xmt_time;   
	int    		alarm;       

}Data_frame_Data_info;


#endif
